# Copyright 2025 Copyright AGNTCY Contributors (https://github.com/agntcy)
# SPDX-License-Identifier: Apache-2.0

# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
"""Client and server classes corresponding to protobuf-defined services."""
import grpc

from agntcy.identity.issuer.v1alpha1 import local_service_pb2 as agntcy_dot_identity_dot_issuer_dot_v1alpha1_dot_local__service__pb2
from google.protobuf import empty_pb2 as google_dot_protobuf_dot_empty__pb2


class LocalServiceStub(object):
    """LocalService is the service that provides LOCAL issuer operations.
    """

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.KeyGen = channel.unary_unary(
                '/agntcy.identity.issuer.v1alpha1.LocalService/KeyGen',
                request_serializer=google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
                response_deserializer=agntcy_dot_identity_dot_issuer_dot_v1alpha1_dot_local__service__pb2.KeyGenResponse.FromString,
                _registered_method=True)
        self.IssueVC = channel.unary_unary(
                '/agntcy.identity.issuer.v1alpha1.LocalService/IssueVC',
                request_serializer=agntcy_dot_identity_dot_issuer_dot_v1alpha1_dot_local__service__pb2.IssueVCRequest.SerializeToString,
                response_deserializer=agntcy_dot_identity_dot_issuer_dot_v1alpha1_dot_local__service__pb2.IssueVCResponse.FromString,
                _registered_method=True)


class LocalServiceServicer(object):
    """LocalService is the service that provides LOCAL issuer operations.
    """

    def KeyGen(self, request, context):
        """Generate a keypair in Json Web Key (JWK) format
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def IssueVC(self, request, context):
        """Issue a Verifiable Credential in a specific Envelope Type
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_LocalServiceServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'KeyGen': grpc.unary_unary_rpc_method_handler(
                    servicer.KeyGen,
                    request_deserializer=google_dot_protobuf_dot_empty__pb2.Empty.FromString,
                    response_serializer=agntcy_dot_identity_dot_issuer_dot_v1alpha1_dot_local__service__pb2.KeyGenResponse.SerializeToString,
            ),
            'IssueVC': grpc.unary_unary_rpc_method_handler(
                    servicer.IssueVC,
                    request_deserializer=agntcy_dot_identity_dot_issuer_dot_v1alpha1_dot_local__service__pb2.IssueVCRequest.FromString,
                    response_serializer=agntcy_dot_identity_dot_issuer_dot_v1alpha1_dot_local__service__pb2.IssueVCResponse.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'agntcy.identity.issuer.v1alpha1.LocalService', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))
    server.add_registered_method_handlers('agntcy.identity.issuer.v1alpha1.LocalService', rpc_method_handlers)


 # This class is part of an EXPERIMENTAL API.
class LocalService(object):
    """LocalService is the service that provides LOCAL issuer operations.
    """

    @staticmethod
    def KeyGen(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/agntcy.identity.issuer.v1alpha1.LocalService/KeyGen',
            google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
            agntcy_dot_identity_dot_issuer_dot_v1alpha1_dot_local__service__pb2.KeyGenResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def IssueVC(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/agntcy.identity.issuer.v1alpha1.LocalService/IssueVC',
            agntcy_dot_identity_dot_issuer_dot_v1alpha1_dot_local__service__pb2.IssueVCRequest.SerializeToString,
            agntcy_dot_identity_dot_issuer_dot_v1alpha1_dot_local__service__pb2.IssueVCResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)
